%global perl_vendorlib %(eval $(perl -V:vendorlib); echo $vendorlib)
%global gitolite_homedir %{_sharedstatedir}/%{name}

Name:           gitolite3
Version:        3.6.13
Release:    	2%{?dist}
Summary:        Highly flexible server for git directory version tracker

License:        GPL-2.0-only AND CC-BY-SA-1.0
URL:            http://github.com/sitaramc/gitolite
Source0:        https://github.com/sitaramc/gitolite/archive/v%{version}.tar.gz
Source1:        gitolite3-README
Source2:        compile-1


BuildArch:      noarch
BuildRequires:      perl-generators
Provides:       perl(%{name}) = %{version}-%{release}
Requires:       git
Requires:       openssh-clients
Requires(pre):  shadow-utils
Recommends:     subversion

%description
Gitolite allows a server to host many git repositories and provide access
to many developers, without having to give them real userids on the server.
The essential magic in doing this is ssh's pubkey access and the authorized
keys file, and the inspiration was an older program called gitosis.

Gitolite can restrict who can read from (clone/fetch) or write to (push) a
repository. It can also restrict who can push to what branch or tag, which
is very important in a corporate environment. Gitolite can be installed
without requiring root permissions, and with no additional software than git
itself and perl. It also has several other neat features described below and
elsewhere in the doc/ directory.


%prep
%setup -qn gitolite-%{version}
cp %{SOURCE1} .


%build

%install
rm -rf %{buildroot}

install -d %{buildroot}%{gitolite_homedir}
install -d %{buildroot}%{gitolite_homedir}/.ssh
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{perl_vendorlib}
install -d %{buildroot}%{_datadir}/%{name}

cp -pr src/lib/Gitolite %{buildroot}%{perl_vendorlib}
echo "%{version}-%{release}" >src/VERSION
cp -a src/* %{buildroot}%{_datadir}/%{name}
cp %{SOURCE2} %{buildroot}%{_datadir}/%{name}/commands/
ln -s %{_datadir}/%{name}/gitolite %{buildroot}%{_bindir}/gitolite

touch %{buildroot}%{gitolite_homedir}/.ssh/authorized_keys


%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || \
useradd -r -g %{name} -d %{gitolite_homedir} -s /bin/sh \
        -c "git repository hosting" %{name}
exit 0


%files
%{_bindir}/*
%{perl_vendorlib}/*
%{_datadir}/%{name}
%attr(750,%{name},%{name}) %dir %{gitolite_homedir}
%attr(750,%{name},%{name}) %dir %{gitolite_homedir}/.ssh
%config(noreplace) %attr(640,%{name},%{name}) %{gitolite_homedir}/.ssh/authorized_keys
%doc gitolite3-README COPYING README.markdown CHANGELOG


%changelog
* Fri Sep 13 2024 bbrucezhang <bbrucezhang@tencent.com> - 3.6.13-2
- Remove not use macros

* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.6.13-1
- initial build
